@startuml

!include shared.puml

title Deployment instances

class Hostgroup FOREMAN
class Host FOREMAN
class Interface FOREMAN
class Subnet FOREMAN

RESOURCES

class HostResource << (C, green) Ordered >>
class ParamUpdateResource << (C, green) Ordered >>
class PuppetRun << (C, green) Ordered >>

hide Resource
hide OrderedResource
hide ChildStackResource

class HostgroupDeployment {
    .. notes ..
    hostgroup created for a given
    resource within given deployment
}
HostgroupDeployment -up-> "1" Deployment
HostgroupDeployment --> "1" Hostgroup
HostgroupDeployment --> "1" HostgroupResource

ParamResource ..> Hostgroup : configures
ParamOverrideResource ..> Hostgroup : configures
PuppetClassResource ..> Hostgroup : configures
ComputeResourceResource ..> Host : limits user's\nselection
ComputeProfileResource ..> Host : limits user's\nselection

class SubnetTypeDeployment {
    .. notes ..
    subnet selection for a given
    resource within given deployment
}
SubnetTypeDeployment -up-> "1" Deployment
SubnetTypeDeployment --> "1" Subnet
SubnetTypeDeployment --> "1" SubnetTypeResource

SubnetTypeResource ..> Host : defines subnet\nrequirements
Interface -up-> Subnet : assigned in

class InterfaceDeployment {
    .. notes ..
    interface created for a given
    resource within given deployment
}
InterfaceDeployment -up-> "1" Deployment
InterfaceDeployment --> "1" Interface
InterfaceDeployment --> "1" InterfaceResource
Interface -up.>  Host : blocks IP\naddresses

class HostDeployment {
    .. notes ..
    host provisioned (not configured)
    for a given resource within given
    deployment
}
HostDeployment -up-> "1" Deployment
HostDeployment --> "1" Host
HostDeployment --> "1" HostResource

ParamUpdateResource ..> Hostgroup : updates

PuppetRun ..> Host : on

RESOURCESASSOCIATIONS

legend right
    After deployment is configured Resources without Ordered module
    are processed first (they just configure Foreman objects).
    Then Ordered Resources are orchestrated in defined order.
end legend

@enduml
